using System;
using System.Configuration;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CSSamples
{
    public partial class UseGoogleYahooWms : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-13939426.6371, 6701997.4056, -7812401.86, 2626987.386962);
                Map1.MapUnit = GeographyUnit.Meter;

                Map1.MapTools.MouseCoordinate.Enabled = true;
                Map1.MapTools.PanZoomBar.Enabled = true;

                WmsOverlay wms = new WmsOverlay("WMS");
                wms.Parameters.Add("layers", "Countries02,USSTATES,USMAJORCITIES");
                wms.Parameters.Add("STYLE", "SIMPLE");
                wms.ServerUris.Add(new Uri("http://wmssamples.thinkgeo.com/WmsServer.aspx"));
                wms.SetBaseEpsgProjection("EPSG:900913");

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/SampleData/world/cntry02.shp"));
                worldLayer.ZoomLevelSet = new GoogleMapZoomLevelSet();
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 243, 239, 228), GeoColor.FromArgb(255, 218, 193, 163), 1);
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                Proj4Projection proj4 = new Proj4Projection();
                proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                worldLayer.FeatureSource.Projection = proj4;

                LayerOverlay worldOverlay = new LayerOverlay("WorldOverlay");
                worldOverlay.Layers.Add(worldLayer);
                worldOverlay.Name = "Layers";
                worldOverlay.SetBaseEpsgProjection("EPSG:900913");

                Map1.CustomOverlays.Add(wms);
                Map1.CustomOverlays.Add(worldOverlay);

                Map1.SyncClientZoomLevels(worldLayer.ZoomLevelSet);
            }
        }
    }
}
